close all;
clear;
clc;

rng('default');
rng(0);         
addpath('Functions')
%T=10000;
T=518;
N=1000;
p=1;
A=[0.2 0.4 0.2;
    0.3 0.7 -.1;
    0.3 -0.2 0.6];
B0=[0.6  0   0;
   -0.3  0.5 0;
   -0.4 -0.1 0.5];

% B0i=inv(B0);
% tre=-B0i(2,1)*[0.5]/B0i(2,2);
% beta0=[0.5;tre;0.5];
beta0=[0;0;0.5];

for k=1:20
    tirf(:,:,k)=A^(k-1)*B0;
    tirf2(:,:,k)=A^(k-1)*beta0;
end
ttirf=[tirf(:,2,:) tirf2];

for jl=1:N
    jl
    c=standardize(randn(T,1));
    a=standardize(randn(T,1));
%     a=pearsrnd(0,1,-0.5,4,T,1);
    b=standardize(randn(T,1));
    d=a.^2;
    e=[c a b];
    x(:,1)=zeros(3,1);
    for t=2:T
        x(:,t)=A*x(:,t-1)+B0*e(t,:)'+beta0*d(t,:)';
    end
    x=x';
    [cirf,boot,sh, covu] = CholeskyBoot(x,p,20,1,1,0.68,[],0);
    Z=([ sh(:,2) sh(:,2).^2]);
    [Y XX]=VarStr(x,1,p);
%     [aaa red]=ols(Y(:,2),[XX Y(:,1) ]);
%     sh=standardize(red);
%     Z=([ sh sh.^2]);
    X=[XX Z];
    D=inv(X'*X)*X'*Y;
    cD=[D(2:end-2,:)';eye(3*(p-1)) zeros(3*(p-1),3)];
    for k=1:20
        temp_irf=cD^(k-1);
        xirf(:,:,k,jl)=temp_irf(1:3,1:3)*D(end-1:end,:)';
    end   
    datavar=x;
    clear x
  
% Bootstrap VARX:

[~,~,eta,~] = CholeskyBoot(datavar,p,20,1,1,0.68,[],0);

finaldata=datavar(p+1:end,:); % endogenous variables of VARX, same as first step

news=[eta(:,2) eta(:,2).^2]; % exogenous variables of VARX

nonlin=1; % Type of nonlinearity (square=1, abs=0)

%restr=0; % no restriction
restr=3; % restriction

m=size(news,2); % # of exogenous variables
q=0;  % # of lags of the exogenous variables

p=1; % # lags 
c=0; % including constant
hor=20; % # horizons of IRFs + 1
cum=0; % IRFs not cumulated
pos_shock=2;
n=3;

SVARX; % estimation of the SVARX

C_wold_loop(:,:,jl*1000-1000+1:jl*1000)=ExtraBigC;
HighC_loop(:,:,jl)=HighC;
LowC_loop(:,:,jl)=LowC;

end


% set(0,'defaultAxesFontName', 'Times');
set(0,'defaultAxesLineStyleOrder','-|-.|:', 'defaultLineLineWidth',1)
var_names={'$x_{1}$';'$x_{2}$';'$x_{3}$'};
shock_names={'$u_{ft}$';'$g(u_{ft})$'};

figure(1)
iii=0;
for i=1:3
    for ii=1:2
        iii=iii+1;
        irf=[squeeze(prctile(xirf(i,ii,:,:),[16 50 84],4))];
        subplot(3,2,iii),PlotShad(irf),hold on
        %plot(squeeze(ttirf(i,ii,:)),'b','LineWidth',1.5,'LineStyle','-.') 
        plot(squeeze(prctile(C_wold_loop(:,iii,:),16,3)),'b','LineWidth',1.5,'LineStyle','-.')
        plot(squeeze(prctile(C_wold_loop(:,iii,:),84,3)),'b','LineWidth',1.5,'LineStyle','-.')
        set(gca,'FontSize',12)
        if ii==2
            ylabel(var_names{i},'Interpreter','Latex')
        end
        if i==1
        title(shock_names{ii},'Interpreter','Latex')    
        end
    end
end

figure(2)
iii=0;
for i=1:3
    for ii=1:2
        iii=iii+1;
        irf=squeeze(prctile(C_wold_loop(:,iii,:),[16 50 84],3));
        subplot(3,2,iii)
        b=fill([1:hor fliplr(1:hor)],[irf(:,1)' flipud(irf(:,3))'],[.7 .7 .7]); hold on;
        set(b,'EdgeAlpha',0)
        plot(squeeze(prctile(xirf(i,ii,:,:),16,4)),'b','LineWidth',1.5,'LineStyle','-.'), hold on;
        plot(squeeze(prctile(xirf(i,ii,:,:),84,4)),'b','LineWidth',1.5,'LineStyle','-.'), hold on;
        z = plot(1:hor,zeros(hor,1));
        set(z(1),'Color','r','LineWidth',1,'LineStyle','-');
        set(gca,'FontSize',12)
        if ii==2
            ylabel(var_names{i},'Interpreter','Latex')
        end
        if i==1
        title(shock_names{ii},'Interpreter','Latex')    
        end
    end
end

figure(3)
iii=0;
for i=1:3
    for ii=1:2
        iii=iii+1;
        irfhigh=squeeze(mean(HighC_loop(:,iii,:),3));
        irflow=squeeze(mean(LowC_loop(:,iii,:),3));
        subplot(3,2,iii)
        b=fill([1:hor fliplr(1:hor)],[irflow' flipud(irfhigh)'],[.7 .7 .7]); hold on;
        set(b,'EdgeAlpha',0)
        plot(squeeze(prctile(xirf(i,ii,:,:),16,4)),'b','LineWidth',1.5,'LineStyle','-.'), hold on;
        plot(squeeze(prctile(xirf(i,ii,:,:),84,4)),'b','LineWidth',1.5,'LineStyle','-.'), hold on;
        z = plot(1:hor,zeros(hor,1));
        set(z(1),'Color','r','LineWidth',1,'LineStyle','-');
        set(gca,'FontSize',12)
        if ii==2
            ylabel(var_names{i},'Interpreter','Latex')
        end
        if i==1
        title(shock_names{ii},'Interpreter','Latex')    
        end
    end
end


%% Coverage rates:

thirf=reshape(permute(ttirf,[3 2 1]),hor,n*m,[]);
coveragerate=zeros(hor,n*m);

for jl=1:N
    jl

    for i=1:hor

        for j=1:n*m

            if squeeze(prctile(C_wold_loop(i,j,jl*N-N+1:jl*N),16,3))<=thirf(i,j) && thirf(i,j)<=squeeze(prctile(C_wold_loop(i,j,jl*N-N+1:jl*N),84,3));
                coveragerate(i,j,jl)=1;
            else, coveragerate(i,j,jl)=0;

            end

        end

    end

end

figure;
plot(0:19,mean(coveragerate,3))
axis([0 19 0 1])
